'use strict';

var jsxRuntime = require('react/jsx-runtime');
var LexicalComposerContext = require('@lexical/react/LexicalComposerContext');
var require$$4 = require('@lexical/utils');
var require$$0 = require('lexical');
var React = require('react');
var reactErrorBoundary = require('react-error-boundary');
var index = require('./index-512be54a.js');
require('@lexical/react/LexicalComposer');
require('@lexical/react/LexicalHistoryPlugin');
require('@lexical/react/LexicalAutoFocusPlugin');
require('@lexical/react/LexicalCharacterLimitPlugin');
require('@lexical/react/LexicalCheckListPlugin');
require('@lexical/react/LexicalClearEditorPlugin');
require('@lexical/react/LexicalClickableLinkPlugin');
require('@lexical/react/LexicalErrorBoundary');
require('@lexical/react/LexicalHashtagPlugin');
require('@lexical/react/LexicalHorizontalRulePlugin');
require('@lexical/react/LexicalListPlugin');
require('@lexical/react/LexicalPlainTextPlugin');
require('@lexical/react/LexicalRichTextPlugin');
require('@lexical/react/LexicalTabIndentationPlugin');
require('@lexical/react/LexicalTablePlugin');
require('@lexical/react/useLexicalEditable');
require('@lexical/code');
require('@lexical/hashtag');
require('@lexical/link');
require('@lexical/list');
require('@lexical/rich-text');
require('@lexical/selection');
require('katex');
require('@lexical/react/LexicalCollaborationContext');
require('yjs');
require('react-dom');
require('@lexical/react/LexicalHorizontalRuleNode');
require('@lexical/table');
require('@lexical/react/LexicalBlockWithAlignableContents');
require('@lexical/react/LexicalDecoratorBlockNode');
require('@lexical/react/LexicalAutoEmbedPlugin');
require('@lexical/react/LexicalAutoLinkPlugin');
require('lodash-es');
require('@lexical/react/LexicalTypeaheadMenuPlugin');
require('katex/dist/katex.css');
require('react-loading-skeleton');
require('@cpchain-foundation/ui');
require('@lexical/react/useLexicalNodeSelection');
require('@lexical/react/LexicalContextMenuPlugin');
require('@lexical/mark');
require('@lexical/react/LexicalEditorRefPlugin');
require('@lexical/react/LexicalOnChangePlugin');
require('@lexical/react/LexicalContentEditable');
require('@lexical/react/useLexicalTextEntity');
require('@lexical/react/LexicalLinkPlugin');
require('@lexical/react/LexicalMarkdownShortcutPlugin');
require('@lexical/react/LexicalTableOfContents');
require('@lexical/react/LexicalTreeView');
require('@lexical/overflow');

var css_248z = "/**\n * Copyright (c) Meta Platforms, Inc. and affiliates.\n *\n * This source code is licensed under the MIT license found in the\n * LICENSE file in the root directory of this source tree.\n *\n *\n */\n\n.EquationEditor_inlineEditor {\n  padding: 0;\n  margin: 0;\n  border: 0;\n  outline: 0;\n  color: #8421a2;\n  background-color: inherit;\n  resize: none;\n}\n\n.EquationEditor_blockEditor {\n  padding: 0;\n  margin: 0;\n  border: 0;\n  outline: 0;\n  color: #8421a2;\n  background-color: inherit;\n  resize: none;\n  width: 100%;\n}\n\n.EquationEditor_inputBackground {\n  background-color: #eee;\n}\n\n.EquationEditor_dollarSign {\n  text-align: left;\n  color: #b0b0b0;\n}\n";
index.styleInject(css_248z);

function EquationEditor({ equation, setEquation, inline }, forwardedRef) {
    const onChange = (event) => {
        setEquation(event.target.value);
    };
    return inline && forwardedRef instanceof HTMLInputElement ? (jsxRuntime.jsxs("span", { className: "EquationEditor_inputBackground", children: [jsxRuntime.jsx("span", { className: "EquationEditor_dollarSign", children: "$" }), jsxRuntime.jsx("input", { className: "EquationEditor_inlineEditor", value: equation, onChange: onChange, autoFocus: true, ref: forwardedRef }), jsxRuntime.jsx("span", { className: "EquationEditor_dollarSign", children: "$" })] })) : (jsxRuntime.jsxs("div", { className: "EquationEditor_inputBackground", children: [jsxRuntime.jsx("span", { className: "EquationEditor_dollarSign", children: '$$\n' }), jsxRuntime.jsx("textarea", { className: "EquationEditor_blockEditor", value: equation, onChange: onChange, ref: forwardedRef }), jsxRuntime.jsx("span", { className: "EquationEditor_dollarSign", children: '\n$$' })] }));
}
var EquationEditor$1 = React.forwardRef(EquationEditor);

function EquationComponent({ equation, inline, nodeKey, }) {
    const [editor] = LexicalComposerContext.useLexicalComposerContext();
    const [equationValue, setEquationValue] = React.useState(equation);
    const [showEquationEditor, setShowEquationEditor] = React.useState(false);
    const inputRef = React.useRef(null);
    const onHide = React.useCallback((restoreSelection) => {
        setShowEquationEditor(false);
        editor.update(() => {
            const node = require$$0.$getNodeByKey(nodeKey);
            if (index.$isEquationNode(node)) {
                node.setEquation(equationValue);
                if (restoreSelection) {
                    node.selectNext(0, 0);
                }
            }
        });
    }, [editor, equationValue, nodeKey]);
    React.useEffect(() => {
        if (!showEquationEditor && equationValue !== equation) {
            setEquationValue(equation);
        }
    }, [showEquationEditor, equation, equationValue]);
    React.useEffect(() => {
        if (showEquationEditor) {
            return require$$4.mergeRegister(editor.registerCommand(require$$0.SELECTION_CHANGE_COMMAND, (payload) => {
                const activeElement = document.activeElement;
                const inputElem = inputRef.current;
                if (inputElem !== activeElement) {
                    onHide();
                }
                return false;
            }, require$$0.COMMAND_PRIORITY_HIGH), editor.registerCommand(require$$0.KEY_ESCAPE_COMMAND, (payload) => {
                const activeElement = document.activeElement;
                const inputElem = inputRef.current;
                if (inputElem === activeElement) {
                    onHide(true);
                    return true;
                }
                return false;
            }, require$$0.COMMAND_PRIORITY_HIGH));
        }
        else {
            return editor.registerUpdateListener(({ editorState }) => {
                const isSelected = editorState.read(() => {
                    const selection = require$$0.$getSelection();
                    return (require$$0.$isNodeSelection(selection) &&
                        selection.has(nodeKey) &&
                        selection.getNodes().length === 1);
                });
                if (isSelected) {
                    setShowEquationEditor(true);
                }
            });
        }
    }, [editor, nodeKey, onHide, showEquationEditor]);
    return (jsxRuntime.jsx(jsxRuntime.Fragment, { children: showEquationEditor ? (jsxRuntime.jsx(EquationEditor$1, { equation: equationValue, setEquation: setEquationValue, inline: inline, ref: inputRef })) : (jsxRuntime.jsx(reactErrorBoundary.ErrorBoundary, { onError: (e) => editor._onError(e), fallback: null, children: jsxRuntime.jsx(index.KatexRenderer, { equation: equationValue, inline: inline, onDoubleClick: () => setShowEquationEditor(true) }) })) }));
}

exports["default"] = EquationComponent;
