'use strict';

var jsxRuntime = require('react/jsx-runtime');
var index = require('./index-512be54a.js');
var LexicalAutoFocusPlugin = require('@lexical/react/LexicalAutoFocusPlugin');
var LexicalCollaborationContext = require('@lexical/react/LexicalCollaborationContext');
var LexicalCollaborationPlugin = require('@lexical/react/LexicalCollaborationPlugin');
var LexicalComposerContext = require('@lexical/react/LexicalComposerContext');
var LexicalErrorBoundary = require('@lexical/react/LexicalErrorBoundary');
var LexicalHashtagPlugin = require('@lexical/react/LexicalHashtagPlugin');
var LexicalHistoryPlugin = require('@lexical/react/LexicalHistoryPlugin');
var LexicalNestedComposer = require('@lexical/react/LexicalNestedComposer');
var LexicalRichTextPlugin = require('@lexical/react/LexicalRichTextPlugin');
var useLexicalNodeSelection = require('@lexical/react/useLexicalNodeSelection');
var require$$4 = require('@lexical/utils');
var require$$0 = require('lexical');
var React = require('react');
var collaboration = require('./collaboration-f6cbe01a.js');
var ImageResizer = require('./ImageResizer-991cf892.js');
require('@lexical/react/LexicalComposer');
require('@lexical/react/LexicalCharacterLimitPlugin');
require('@lexical/react/LexicalCheckListPlugin');
require('@lexical/react/LexicalClearEditorPlugin');
require('@lexical/react/LexicalClickableLinkPlugin');
require('@lexical/react/LexicalHorizontalRulePlugin');
require('@lexical/react/LexicalListPlugin');
require('@lexical/react/LexicalPlainTextPlugin');
require('@lexical/react/LexicalTabIndentationPlugin');
require('@lexical/react/LexicalTablePlugin');
require('@lexical/react/useLexicalEditable');
require('@lexical/code');
require('@lexical/hashtag');
require('@lexical/link');
require('@lexical/list');
require('@lexical/rich-text');
require('@lexical/selection');
require('katex');
require('yjs');
require('react-dom');
require('@lexical/react/LexicalHorizontalRuleNode');
require('@lexical/table');
require('@lexical/react/LexicalBlockWithAlignableContents');
require('@lexical/react/LexicalDecoratorBlockNode');
require('@lexical/react/LexicalAutoEmbedPlugin');
require('@lexical/react/LexicalAutoLinkPlugin');
require('lodash-es');
require('@lexical/react/LexicalTypeaheadMenuPlugin');
require('katex/dist/katex.css');
require('react-error-boundary');
require('react-loading-skeleton');
require('@cpchain-foundation/ui');
require('@lexical/react/LexicalContextMenuPlugin');
require('@lexical/mark');
require('@lexical/react/LexicalEditorRefPlugin');
require('@lexical/react/LexicalOnChangePlugin');
require('@lexical/react/LexicalContentEditable');
require('@lexical/react/useLexicalTextEntity');
require('@lexical/react/LexicalLinkPlugin');
require('@lexical/react/LexicalMarkdownShortcutPlugin');
require('@lexical/react/LexicalTableOfContents');
require('@lexical/react/LexicalTreeView');
require('@lexical/overflow');
require('y-websocket');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var LexicalErrorBoundary__default = /*#__PURE__*/_interopDefaultLegacy(LexicalErrorBoundary);

var css_248z = "/**\n * Copyright (c) Meta Platforms, Inc. and affiliates.\n *\n * This source code is licensed under the MIT license found in the\n * LICENSE file in the root directory of this source tree.\n *\n *\n */\n\n.ImageNode__contentEditable {\n  min-height: 20px;\n  border: 0px;\n  resize: none;\n  cursor: text;\n  caret-color: rgb(5, 5, 5);\n  display: block;\n  position: relative;\n  outline: 0px;\n  padding: 10px;\n  -webkit-user-select: text;\n     -moz-user-select: text;\n          user-select: text;\n  font-size: 12px;\n  width: calc(100% - 20px);\n  white-space: pre-wrap;\n  word-break: break-word;\n}\n\n.ImageNode__placeholder {\n  font-size: 12px;\n  color: #888;\n  overflow: hidden;\n  position: absolute;\n  text-overflow: ellipsis;\n  top: 10px;\n  left: 10px;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n  white-space: nowrap;\n  display: inline-block;\n  pointer-events: none;\n}\n\n.image-control-wrapper--resizing {\n  touch-action: none;\n}\n";
index.styleInject(css_248z);

const imageCache = new Set();
function useSuspenseImage(src) {
    if (!imageCache.has(src)) {
        throw new Promise((resolve) => {
            const img = new Image();
            img.src = src;
            img.onload = () => {
                imageCache.add(src);
                resolve(null);
            };
        });
    }
}
function LazyImage({ altText, className, imageRef, src, width, height, maxWidth, }) {
    useSuspenseImage(src);
    return (jsxRuntime.jsx("img", { className: className || undefined, src: src, alt: altText, ref: imageRef, style: {
            height,
            maxWidth,
            width,
        }, draggable: "false" }));
}
function ImageComponent({ src, altText, nodeKey, width, height, maxWidth, resizable, showCaption, caption, captionsEnabled, }) {
    const imageRef = React.useRef(null);
    const buttonRef = React.useRef(null);
    const [isSelected, setSelected, clearSelection] = useLexicalNodeSelection.useLexicalNodeSelection(nodeKey);
    const [isResizing, setIsResizing] = React.useState(false);
    const { isCollabActive } = LexicalCollaborationContext.useCollaborationContext();
    const [editor] = LexicalComposerContext.useLexicalComposerContext();
    const [selection, setSelection] = React.useState(null);
    const activeEditorRef = React.useRef(null);
    const onDelete = React.useCallback((payload) => {
        if (isSelected && require$$0.$isNodeSelection(require$$0.$getSelection())) {
            const event = payload;
            event.preventDefault();
            const node = require$$0.$getNodeByKey(nodeKey);
            if (index.$isImageNode(node)) {
                node.remove();
            }
        }
        return false;
    }, [isSelected, nodeKey]);
    const onEnter = React.useCallback((event) => {
        const latestSelection = require$$0.$getSelection();
        const buttonElem = buttonRef.current;
        if (isSelected &&
            require$$0.$isNodeSelection(latestSelection) &&
            latestSelection.getNodes().length === 1) {
            if (showCaption) {
                // Move focus into nested editor
                require$$0.$setSelection(null);
                event.preventDefault();
                caption.focus();
                return true;
            }
            else if (buttonElem !== null &&
                buttonElem !== document.activeElement) {
                event.preventDefault();
                buttonElem.focus();
                return true;
            }
        }
        return false;
    }, [caption, isSelected, showCaption]);
    const onEscape = React.useCallback((event) => {
        if (activeEditorRef.current === caption ||
            buttonRef.current === event.target) {
            require$$0.$setSelection(null);
            editor.update(() => {
                setSelected(true);
                const parentRootElement = editor.getRootElement();
                if (parentRootElement !== null) {
                    parentRootElement.focus();
                }
            });
            return true;
        }
        return false;
    }, [caption, editor, setSelected]);
    React.useEffect(() => {
        let isMounted = true;
        const unregister = require$$4.mergeRegister(editor.registerUpdateListener(({ editorState }) => {
            if (isMounted) {
                setSelection(editorState.read(() => require$$0.$getSelection()));
            }
        }), editor.registerCommand(require$$0.SELECTION_CHANGE_COMMAND, (_, activeEditor) => {
            activeEditorRef.current = activeEditor;
            return false;
        }, require$$0.COMMAND_PRIORITY_LOW), editor.registerCommand(require$$0.CLICK_COMMAND, (payload) => {
            const event = payload;
            if (isResizing) {
                return true;
            }
            if (event.target === imageRef.current) {
                if (event.shiftKey) {
                    setSelected(!isSelected);
                }
                else {
                    clearSelection();
                    setSelected(true);
                }
                return true;
            }
            return false;
        }, require$$0.COMMAND_PRIORITY_LOW), editor.registerCommand(require$$0.DRAGSTART_COMMAND, (event) => {
            if (event.target === imageRef.current) {
                // TODO This is just a temporary workaround for FF to behave like other browsers.
                // Ideally, this handles drag & drop too (and all browsers).
                event.preventDefault();
                return true;
            }
            return false;
        }, require$$0.COMMAND_PRIORITY_LOW), editor.registerCommand(require$$0.KEY_DELETE_COMMAND, onDelete, require$$0.COMMAND_PRIORITY_LOW), editor.registerCommand(require$$0.KEY_BACKSPACE_COMMAND, onDelete, require$$0.COMMAND_PRIORITY_LOW), editor.registerCommand(require$$0.KEY_ENTER_COMMAND, onEnter, require$$0.COMMAND_PRIORITY_LOW), editor.registerCommand(require$$0.KEY_ESCAPE_COMMAND, onEscape, require$$0.COMMAND_PRIORITY_LOW));
        return () => {
            isMounted = false;
            unregister();
        };
    }, [
        clearSelection,
        editor,
        isResizing,
        isSelected,
        nodeKey,
        onDelete,
        onEnter,
        onEscape,
        setSelected,
    ]);
    const setShowCaption = () => {
        editor.update(() => {
            const node = require$$0.$getNodeByKey(nodeKey);
            if (index.$isImageNode(node)) {
                node.setShowCaption(true);
            }
        });
    };
    const onResizeEnd = (nextWidth, nextHeight) => {
        // Delay hiding the resize bars for click case
        setTimeout(() => {
            setIsResizing(false);
        }, 200);
        editor.update(() => {
            const node = require$$0.$getNodeByKey(nodeKey);
            if (index.$isImageNode(node)) {
                node.setWidthAndHeight(nextWidth, nextHeight);
            }
        });
    };
    const onResizeStart = () => {
        setIsResizing(true);
    };
    const { historyState } = index.useSharedHistoryContext();
    const { settings: { showNestedEditorTreeView }, } = index.useSettings();
    const draggable = isSelected && require$$0.$isNodeSelection(selection) && !isResizing;
    const isFocused = isSelected || isResizing;
    return (jsxRuntime.jsx(React.Suspense, { fallback: null, children: jsxRuntime.jsxs(jsxRuntime.Fragment, { children: [jsxRuntime.jsx("div", { draggable: draggable, children: jsxRuntime.jsx(LazyImage, { className: isFocused
                            ? `focused ${require$$0.$isNodeSelection(selection) ? 'draggable' : ''}`
                            : null, src: src, altText: altText, imageRef: imageRef, width: width, height: height, maxWidth: maxWidth }) }), showCaption && (jsxRuntime.jsx("div", { className: "image-caption-container", children: jsxRuntime.jsxs(LexicalNestedComposer.LexicalNestedComposer, { initialEditor: caption, children: [jsxRuntime.jsx(LexicalAutoFocusPlugin.AutoFocusPlugin, {}), jsxRuntime.jsx(index.NewMentionsPlugin, {}), jsxRuntime.jsx(index.LinkPlugin, {}), jsxRuntime.jsx(index.EmojisPlugin, {}), jsxRuntime.jsx(LexicalHashtagPlugin.HashtagPlugin, {}), jsxRuntime.jsx(index.KeywordsPlugin, {}), isCollabActive ? (jsxRuntime.jsx(LexicalCollaborationPlugin.CollaborationPlugin, { id: caption.getKey(), providerFactory: collaboration.createWebsocketProvider, shouldBootstrap: true })) : (jsxRuntime.jsx(LexicalHistoryPlugin.HistoryPlugin, { externalHistoryState: historyState })), jsxRuntime.jsx(LexicalRichTextPlugin.RichTextPlugin, { contentEditable: jsxRuntime.jsx(index.LexicalContentEditable, { className: "ImageNode__contentEditable" }), placeholder: jsxRuntime.jsx(index.Placeholder, { className: "ImageNode__placeholder", children: "Enter a caption..." }), ErrorBoundary: LexicalErrorBoundary__default["default"] }), showNestedEditorTreeView === true ? jsxRuntime.jsx(index.TreeViewPlugin, {}) : null] }) })), resizable && require$$0.$isNodeSelection(selection) && isFocused && (jsxRuntime.jsx(ImageResizer.ImageResizer, { showCaption: showCaption, setShowCaption: setShowCaption, editor: editor, buttonRef: buttonRef, imageRef: imageRef, maxWidth: maxWidth, onResizeStart: onResizeStart, onResizeEnd: onResizeEnd, captionsEnabled: captionsEnabled }))] }) }));
}

exports["default"] = ImageComponent;
