'use strict';

var jsxRuntime = require('react/jsx-runtime');
var index = require('./index-512be54a.js');
var LexicalAutoFocusPlugin = require('@lexical/react/LexicalAutoFocusPlugin');
var LexicalComposerContext = require('@lexical/react/LexicalComposerContext');
var LexicalErrorBoundary = require('@lexical/react/LexicalErrorBoundary');
var LexicalNestedComposer = require('@lexical/react/LexicalNestedComposer');
var LexicalRichTextPlugin = require('@lexical/react/LexicalRichTextPlugin');
var useLexicalNodeSelection = require('@lexical/react/useLexicalNodeSelection');
var require$$4 = require('@lexical/utils');
var require$$0 = require('lexical');
var React = require('react');
require('@lexical/react/LexicalComposer');
require('@lexical/react/LexicalHistoryPlugin');
require('@lexical/react/LexicalCharacterLimitPlugin');
require('@lexical/react/LexicalCheckListPlugin');
require('@lexical/react/LexicalClearEditorPlugin');
require('@lexical/react/LexicalClickableLinkPlugin');
require('@lexical/react/LexicalHashtagPlugin');
require('@lexical/react/LexicalHorizontalRulePlugin');
require('@lexical/react/LexicalListPlugin');
require('@lexical/react/LexicalPlainTextPlugin');
require('@lexical/react/LexicalTabIndentationPlugin');
require('@lexical/react/LexicalTablePlugin');
require('@lexical/react/useLexicalEditable');
require('@lexical/code');
require('@lexical/hashtag');
require('@lexical/link');
require('@lexical/list');
require('@lexical/rich-text');
require('@lexical/selection');
require('katex');
require('@lexical/react/LexicalCollaborationContext');
require('yjs');
require('react-dom');
require('@lexical/react/LexicalHorizontalRuleNode');
require('@lexical/table');
require('@lexical/react/LexicalBlockWithAlignableContents');
require('@lexical/react/LexicalDecoratorBlockNode');
require('@lexical/react/LexicalAutoEmbedPlugin');
require('@lexical/react/LexicalAutoLinkPlugin');
require('lodash-es');
require('@lexical/react/LexicalTypeaheadMenuPlugin');
require('katex/dist/katex.css');
require('react-error-boundary');
require('react-loading-skeleton');
require('@cpchain-foundation/ui');
require('@lexical/react/LexicalContextMenuPlugin');
require('@lexical/mark');
require('@lexical/react/LexicalEditorRefPlugin');
require('@lexical/react/LexicalOnChangePlugin');
require('@lexical/react/LexicalContentEditable');
require('@lexical/react/useLexicalTextEntity');
require('@lexical/react/LexicalLinkPlugin');
require('@lexical/react/LexicalMarkdownShortcutPlugin');
require('@lexical/react/LexicalTableOfContents');
require('@lexical/react/LexicalTreeView');
require('@lexical/overflow');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var LexicalErrorBoundary__default = /*#__PURE__*/_interopDefaultLegacy(LexicalErrorBoundary);

function Select(_a) {
    var { children, label, className } = _a, other = index.__rest(_a, ["children", "label", "className"]);
    return (jsxRuntime.jsxs("div", { className: "Input__wrapper", children: [jsxRuntime.jsx("label", { style: { marginTop: '-1em' }, className: "Input__label", children: label }), jsxRuntime.jsx("select", Object.assign({}, other, { className: className || 'select', children: children }))] }));
}

var css_248z = "/**\n * Copyright (c) Meta Platforms, Inc. and affiliates.\n *\n * This source code is licensed under the MIT license found in the\n * LICENSE file in the root directory of this source tree.\n *\n *\n */\n\n.InlineImageNode__contentEditable {\n  min-height: 20px;\n  border: 0px;\n  resize: none;\n  cursor: text;\n  caret-color: rgb(5, 5, 5);\n  display: block;\n  position: relative;\n  -moz-tab-size: 1;\n    -o-tab-size: 1;\n       tab-size: 1;\n  outline: 0px;\n  padding: 10px;\n  -webkit-user-select: text;\n     -moz-user-select: text;\n          user-select: text;\n  font-size: 14px;\n  line-height: 1.4em;\n  width: calc(100% - 20px);\n  white-space: pre-wrap;\n  word-break: break-word;\n}\n\n.InlineImageNode__placeholder {\n  font-size: 12px;\n  color: #888;\n  overflow: hidden;\n  position: absolute;\n  text-overflow: ellipsis;\n  bottom: 10px;\n  left: 10px;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n  white-space: nowrap;\n  display: inline-block;\n  pointer-events: none;\n}\n";
index.styleInject(css_248z);

const imageCache = new Set();
function useSuspenseImage(src) {
    if (!imageCache.has(src)) {
        throw new Promise((resolve) => {
            const img = new Image();
            img.src = src;
            img.onload = () => {
                imageCache.add(src);
                resolve(null);
            };
        });
    }
}
function LazyImage({ altText, className, imageRef, src, width, height, position, }) {
    useSuspenseImage(src);
    return (jsxRuntime.jsx("img", { className: className || undefined, src: src, alt: altText, ref: imageRef, "data-position": position, style: {
            display: 'block',
            height,
            width,
        }, draggable: "false" }));
}
function UpdateInlineImageDialog({ activeEditor, nodeKey, onClose, }) {
    const editorState = activeEditor.getEditorState();
    const node = editorState.read(() => require$$0.$getNodeByKey(nodeKey));
    const [altText, setAltText] = React.useState(node.getAltText());
    const [showCaption, setShowCaption] = React.useState(node.getShowCaption());
    const [position, setPosition] = React.useState(node.getPosition());
    const handleShowCaptionChange = (e) => {
        setShowCaption(e.target.checked);
    };
    const handlePositionChange = (e) => {
        setPosition(e.target.value);
    };
    const handleOnConfirm = () => {
        const payload = { altText, position, showCaption };
        if (node) {
            activeEditor.update(() => {
                node.update(payload);
            });
        }
        onClose();
    };
    return (jsxRuntime.jsxs(jsxRuntime.Fragment, { children: [jsxRuntime.jsx("div", { style: { marginBottom: '1em' }, children: jsxRuntime.jsx(index.TextInput, { label: "Alt Text", placeholder: "Descriptive alternative text", onChange: setAltText, value: altText, "data-test-id": "image-modal-alt-text-input" }) }), jsxRuntime.jsxs(Select, { style: { marginBottom: '1em', width: '208px' }, value: position, label: "Position", name: "position", id: "position-select", onChange: handlePositionChange, children: [jsxRuntime.jsx("option", { value: "left", children: "Left" }), jsxRuntime.jsx("option", { value: "right", children: "Right" }), jsxRuntime.jsx("option", { value: "full", children: "Full Width" })] }), jsxRuntime.jsxs("div", { className: "Input__wrapper", children: [jsxRuntime.jsx("input", { id: "caption", type: "checkbox", checked: showCaption, onChange: handleShowCaptionChange }), jsxRuntime.jsx("label", { htmlFor: "caption", children: "Show Caption" })] }), jsxRuntime.jsx(index.DialogActions, { children: jsxRuntime.jsx(index.Button, { "data-test-id": "image-modal-file-upload-btn", onClick: () => handleOnConfirm(), children: "Confirm" }) })] }));
}
function InlineImageComponent({ src, altText, nodeKey, width, height, showCaption, caption, position, }) {
    const [modal, showModal] = index.useModal();
    const imageRef = React.useRef(null);
    const buttonRef = React.useRef(null);
    const [isSelected, setSelected, clearSelection] = useLexicalNodeSelection.useLexicalNodeSelection(nodeKey);
    const [editor] = LexicalComposerContext.useLexicalComposerContext();
    const [selection, setSelection] = React.useState(null);
    const activeEditorRef = React.useRef(null);
    const onDelete = React.useCallback((payload) => {
        if (isSelected && require$$0.$isNodeSelection(require$$0.$getSelection())) {
            const event = payload;
            event.preventDefault();
            const node = require$$0.$getNodeByKey(nodeKey);
            if (index.$isInlineImageNode(node)) {
                node.remove();
            }
        }
        return false;
    }, [isSelected, nodeKey]);
    const onEnter = React.useCallback((event) => {
        const latestSelection = require$$0.$getSelection();
        const buttonElem = buttonRef.current;
        if (isSelected &&
            require$$0.$isNodeSelection(latestSelection) &&
            latestSelection.getNodes().length === 1) {
            if (showCaption) {
                // Move focus into nested editor
                require$$0.$setSelection(null);
                event.preventDefault();
                caption.focus();
                return true;
            }
            else if (buttonElem !== null &&
                buttonElem !== document.activeElement) {
                event.preventDefault();
                buttonElem.focus();
                return true;
            }
        }
        return false;
    }, [caption, isSelected, showCaption]);
    const onEscape = React.useCallback((event) => {
        if (activeEditorRef.current === caption ||
            buttonRef.current === event.target) {
            require$$0.$setSelection(null);
            editor.update(() => {
                setSelected(true);
                const parentRootElement = editor.getRootElement();
                if (parentRootElement !== null) {
                    parentRootElement.focus();
                }
            });
            return true;
        }
        return false;
    }, [caption, editor, setSelected]);
    React.useEffect(() => {
        let isMounted = true;
        const unregister = require$$4.mergeRegister(editor.registerUpdateListener(({ editorState }) => {
            if (isMounted) {
                setSelection(editorState.read(() => require$$0.$getSelection()));
            }
        }), editor.registerCommand(require$$0.SELECTION_CHANGE_COMMAND, (_, activeEditor) => {
            activeEditorRef.current = activeEditor;
            return false;
        }, require$$0.COMMAND_PRIORITY_LOW), editor.registerCommand(require$$0.CLICK_COMMAND, (payload) => {
            const event = payload;
            if (event.target === imageRef.current) {
                if (event.shiftKey) {
                    setSelected(!isSelected);
                }
                else {
                    clearSelection();
                    setSelected(true);
                }
                return true;
            }
            return false;
        }, require$$0.COMMAND_PRIORITY_LOW), editor.registerCommand(require$$0.DRAGSTART_COMMAND, (event) => {
            if (event.target === imageRef.current) {
                // TODO This is just a temporary workaround for FF to behave like other browsers.
                // Ideally, this handles drag & drop too (and all browsers).
                event.preventDefault();
                return true;
            }
            return false;
        }, require$$0.COMMAND_PRIORITY_LOW), editor.registerCommand(require$$0.KEY_DELETE_COMMAND, onDelete, require$$0.COMMAND_PRIORITY_LOW), editor.registerCommand(require$$0.KEY_BACKSPACE_COMMAND, onDelete, require$$0.COMMAND_PRIORITY_LOW), editor.registerCommand(require$$0.KEY_ENTER_COMMAND, onEnter, require$$0.COMMAND_PRIORITY_LOW), editor.registerCommand(require$$0.KEY_ESCAPE_COMMAND, onEscape, require$$0.COMMAND_PRIORITY_LOW));
        return () => {
            isMounted = false;
            unregister();
        };
    }, [
        clearSelection,
        editor,
        isSelected,
        nodeKey,
        onDelete,
        onEnter,
        onEscape,
        setSelected,
    ]);
    const draggable = isSelected && require$$0.$isNodeSelection(selection);
    const isFocused = isSelected;
    return (jsxRuntime.jsxs(React.Suspense, { fallback: null, children: [jsxRuntime.jsxs(jsxRuntime.Fragment, { children: [jsxRuntime.jsxs("div", { draggable: draggable, children: [jsxRuntime.jsx("button", { className: "image-edit-button", ref: buttonRef, onClick: () => {
                                    showModal('Update Inline Image', (onClose) => (jsxRuntime.jsx(UpdateInlineImageDialog, { activeEditor: editor, nodeKey: nodeKey, onClose: onClose })));
                                }, children: "Edit" }), jsxRuntime.jsx(LazyImage, { className: isFocused
                                    ? `focused ${require$$0.$isNodeSelection(selection) ? 'draggable' : ''}`
                                    : null, src: src, altText: altText, imageRef: imageRef, width: width, height: height, position: position })] }), showCaption && (jsxRuntime.jsx("div", { className: "image-caption-container", children: jsxRuntime.jsxs(LexicalNestedComposer.LexicalNestedComposer, { initialEditor: caption, children: [jsxRuntime.jsx(LexicalAutoFocusPlugin.AutoFocusPlugin, {}), jsxRuntime.jsx(index.LinkPlugin, {}), jsxRuntime.jsx(index.FloatingLinkEditorPlugin, {}), jsxRuntime.jsx(index.FloatingTextFormatToolbarPlugin, {}), jsxRuntime.jsx(LexicalRichTextPlugin.RichTextPlugin, { contentEditable: jsxRuntime.jsx(index.LexicalContentEditable, { className: "InlineImageNode__contentEditable" }), placeholder: jsxRuntime.jsx(index.Placeholder, { className: "InlineImageNode__placeholder", children: "Enter a caption..." }), ErrorBoundary: LexicalErrorBoundary__default["default"] })] }) }))] }), modal] }));
}

exports.UpdateInlineImageDialog = UpdateInlineImageDialog;
exports["default"] = InlineImageComponent;
