'use strict';

var jsxRuntime = require('react/jsx-runtime');
var index = require('./index-512be54a.js');
var LexicalCollaborationContext = require('@lexical/react/LexicalCollaborationContext');
var LexicalCollaborationPlugin = require('@lexical/react/LexicalCollaborationPlugin');
var LexicalComposerContext = require('@lexical/react/LexicalComposerContext');
var LexicalErrorBoundary = require('@lexical/react/LexicalErrorBoundary');
var LexicalHistoryPlugin = require('@lexical/react/LexicalHistoryPlugin');
var LexicalNestedComposer = require('@lexical/react/LexicalNestedComposer');
var LexicalPlainTextPlugin = require('@lexical/react/LexicalPlainTextPlugin');
var require$$0 = require('lexical');
var React = require('react');
var collaboration = require('./collaboration-f6cbe01a.js');
require('@lexical/react/LexicalComposer');
require('@lexical/react/LexicalAutoFocusPlugin');
require('@lexical/react/LexicalCharacterLimitPlugin');
require('@lexical/react/LexicalCheckListPlugin');
require('@lexical/react/LexicalClearEditorPlugin');
require('@lexical/react/LexicalClickableLinkPlugin');
require('@lexical/react/LexicalHashtagPlugin');
require('@lexical/react/LexicalHorizontalRulePlugin');
require('@lexical/react/LexicalListPlugin');
require('@lexical/react/LexicalRichTextPlugin');
require('@lexical/react/LexicalTabIndentationPlugin');
require('@lexical/react/LexicalTablePlugin');
require('@lexical/react/useLexicalEditable');
require('@lexical/code');
require('@lexical/hashtag');
require('@lexical/link');
require('@lexical/list');
require('@lexical/rich-text');
require('@lexical/selection');
require('@lexical/utils');
require('katex');
require('yjs');
require('react-dom');
require('@lexical/react/LexicalHorizontalRuleNode');
require('@lexical/table');
require('@lexical/react/LexicalBlockWithAlignableContents');
require('@lexical/react/LexicalDecoratorBlockNode');
require('@lexical/react/LexicalAutoEmbedPlugin');
require('@lexical/react/LexicalAutoLinkPlugin');
require('lodash-es');
require('@lexical/react/LexicalTypeaheadMenuPlugin');
require('katex/dist/katex.css');
require('react-error-boundary');
require('react-loading-skeleton');
require('@cpchain-foundation/ui');
require('@lexical/react/useLexicalNodeSelection');
require('@lexical/react/LexicalContextMenuPlugin');
require('@lexical/mark');
require('@lexical/react/LexicalEditorRefPlugin');
require('@lexical/react/LexicalOnChangePlugin');
require('@lexical/react/LexicalContentEditable');
require('@lexical/react/useLexicalTextEntity');
require('@lexical/react/LexicalLinkPlugin');
require('@lexical/react/LexicalMarkdownShortcutPlugin');
require('@lexical/react/LexicalTableOfContents');
require('@lexical/react/LexicalTreeView');
require('@lexical/overflow');
require('y-websocket');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var LexicalErrorBoundary__default = /*#__PURE__*/_interopDefaultLegacy(LexicalErrorBoundary);

var css_248z$1 = "/**\n * Copyright (c) Meta Platforms, Inc. and affiliates.\n *\n * This source code is licensed under the MIT license found in the\n * LICENSE file in the root directory of this source tree.\n *\n *\n */\n.StickyNode__contentEditable {\n  min-height: 20px;\n  border: 0;\n  resize: none;\n  cursor: text;\n  font-size: 24px;\n  caret-color: rgb(5, 5, 5);\n  display: block;\n  position: relative;\n  outline: 0;\n  padding: 10px;\n  -webkit-user-select: text;\n     -moz-user-select: text;\n          user-select: text;\n  white-space: pre-wrap;\n  word-wrap: break-word;\n}\n.StickyNode__placeholder {\n  font-size: 24px;\n  color: #999;\n  overflow: hidden;\n  position: absolute;\n  text-overflow: ellipsis;\n  top: 30px;\n  left: 20px;\n  width: 120px;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n  white-space: nowrap;\n  display: inline-block;\n  pointer-events: none;\n}\n";
index.styleInject(css_248z$1);

var css_248z = "/**\n * Copyright (c) Meta Platforms, Inc. and affiliates.\n *\n * This source code is licensed under the MIT license found in the\n * LICENSE file in the root directory of this source tree.\n *\n *\n */\n\n.StickyEditorTheme__paragraph {\n  margin: 0;\n  position: 'relative';\n}\n";
index.styleInject(css_248z);

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */
const theme = Object.assign(Object.assign({}, index.theme), { paragraph: 'StickyEditorTheme__paragraph' });
var StickyEditorTheme = theme;

function positionSticky(stickyElem, positioning) {
    const style = stickyElem.style;
    const rootElementRect = positioning.rootElementRect;
    const rectLeft = rootElementRect !== null ? rootElementRect.left : 0;
    const rectTop = rootElementRect !== null ? rootElementRect.top : 0;
    style.top = rectTop + positioning.y + 'px';
    style.left = rectLeft + positioning.x + 'px';
}
function StickyComponent({ x, y, nodeKey, color, caption, }) {
    const [editor] = LexicalComposerContext.useLexicalComposerContext();
    const stickyContainerRef = React.useRef(null);
    const positioningRef = React.useRef({
        isDragging: false,
        offsetX: 0,
        offsetY: 0,
        rootElementRect: null,
        x: 0,
        y: 0,
    });
    const { isCollabActive } = LexicalCollaborationContext.useCollaborationContext();
    React.useEffect(() => {
        const position = positioningRef.current;
        position.x = x;
        position.y = y;
        const stickyContainer = stickyContainerRef.current;
        if (stickyContainer !== null) {
            positionSticky(stickyContainer, position);
        }
    }, [x, y]);
    React.useLayoutEffect(() => {
        const position = positioningRef.current;
        const resizeObserver = new ResizeObserver((entries) => {
            for (let i = 0; i < entries.length; i++) {
                const entry = entries[i];
                const { target } = entry;
                position.rootElementRect = target.getBoundingClientRect();
                const stickyContainer = stickyContainerRef.current;
                if (stickyContainer !== null) {
                    positionSticky(stickyContainer, position);
                }
            }
        });
        const removeRootListener = editor.registerRootListener((nextRootElem, prevRootElem) => {
            if (prevRootElem !== null) {
                resizeObserver.unobserve(prevRootElem);
            }
            if (nextRootElem !== null) {
                resizeObserver.observe(nextRootElem);
            }
        });
        const handleWindowResize = () => {
            const rootElement = editor.getRootElement();
            const stickyContainer = stickyContainerRef.current;
            if (rootElement !== null && stickyContainer !== null) {
                position.rootElementRect = rootElement.getBoundingClientRect();
                positionSticky(stickyContainer, position);
            }
        };
        window.addEventListener('resize', handleWindowResize);
        return () => {
            window.removeEventListener('resize', handleWindowResize);
            removeRootListener();
        };
    }, [editor]);
    React.useEffect(() => {
        const stickyContainer = stickyContainerRef.current;
        if (stickyContainer !== null) {
            // Delay adding transition so we don't trigger the
            // transition on load of the sticky.
            setTimeout(() => {
                stickyContainer.style.setProperty('transition', 'top 0.3s ease 0s, left 0.3s ease 0s');
            }, 500);
        }
    }, []);
    const handlePointerMove = (event) => {
        const stickyContainer = stickyContainerRef.current;
        const positioning = positioningRef.current;
        const rootElementRect = positioning.rootElementRect;
        if (stickyContainer !== null &&
            positioning.isDragging &&
            rootElementRect !== null) {
            positioning.x = event.pageX - positioning.offsetX - rootElementRect.left;
            positioning.y = event.pageY - positioning.offsetY - rootElementRect.top;
            positionSticky(stickyContainer, positioning);
        }
    };
    const handlePointerUp = (event) => {
        const stickyContainer = stickyContainerRef.current;
        const positioning = positioningRef.current;
        if (stickyContainer !== null) {
            positioning.isDragging = false;
            stickyContainer.classList.remove('dragging');
            editor.update(() => {
                const node = require$$0.$getNodeByKey(nodeKey);
                if (index.$isStickyNode(node)) {
                    node.setPosition(positioning.x, positioning.y);
                }
            });
        }
        document.removeEventListener('pointermove', handlePointerMove);
        document.removeEventListener('pointerup', handlePointerUp);
    };
    const handleDelete = () => {
        editor.update(() => {
            const node = require$$0.$getNodeByKey(nodeKey);
            if (index.$isStickyNode(node)) {
                node.remove();
            }
        });
    };
    const handleColorChange = () => {
        editor.update(() => {
            const node = require$$0.$getNodeByKey(nodeKey);
            if (index.$isStickyNode(node)) {
                node.toggleColor();
            }
        });
    };
    const { historyState } = index.useSharedHistoryContext();
    return (jsxRuntime.jsx("div", { ref: stickyContainerRef, className: "sticky-note-container", children: jsxRuntime.jsxs("div", { className: `sticky-note ${color}`, onPointerDown: (event) => {
                const stickyContainer = stickyContainerRef.current;
                if (stickyContainer == null ||
                    event.button === 2 ||
                    event.target !== stickyContainer.firstChild) {
                    // Right click or click on editor should not work
                    return;
                }
                const stickContainer = stickyContainer;
                const positioning = positioningRef.current;
                if (stickContainer !== null) {
                    const { top, left } = stickContainer.getBoundingClientRect();
                    positioning.offsetX = event.clientX - left;
                    positioning.offsetY = event.clientY - top;
                    positioning.isDragging = true;
                    stickContainer.classList.add('dragging');
                    document.addEventListener('pointermove', handlePointerMove);
                    document.addEventListener('pointerup', handlePointerUp);
                    event.preventDefault();
                }
            }, children: [jsxRuntime.jsx("button", { onClick: handleDelete, className: "delete", "aria-label": "Delete sticky note", title: "Delete", children: "X" }), jsxRuntime.jsx("button", { onClick: handleColorChange, className: "color", "aria-label": "Change sticky note color", title: "Color", children: jsxRuntime.jsx("i", { className: "bucket" }) }), jsxRuntime.jsxs(LexicalNestedComposer.LexicalNestedComposer, { initialEditor: caption, initialTheme: StickyEditorTheme, children: [isCollabActive ? (jsxRuntime.jsx(LexicalCollaborationPlugin.CollaborationPlugin, { id: caption.getKey(), providerFactory: collaboration.createWebsocketProvider, shouldBootstrap: true })) : (jsxRuntime.jsx(LexicalHistoryPlugin.HistoryPlugin, { externalHistoryState: historyState })), jsxRuntime.jsx(LexicalPlainTextPlugin.PlainTextPlugin, { contentEditable: jsxRuntime.jsx(index.LexicalContentEditable, { className: "StickyNode__contentEditable" }), placeholder: jsxRuntime.jsx(index.Placeholder, { className: "StickyNode__placeholder", children: "What's up?" }), ErrorBoundary: LexicalErrorBoundary__default["default"] })] })] }) }));
}

exports["default"] = StickyComponent;
