type ActionType = 'same' | 'remove' | 'add';
type Diff<T> = {
    value: T;
    type: ActionType;
};
type GroupDiff<T> = {
    value: T[];
    type: ActionType;
};
/**
 * 根据类型合并 diff，例如连续的 add 合并为同一个 add
 * @param array
 * @returns
 */
export declare function groupDiff<T>(array: Diff<T>[]): GroupDiff<T>[];
/**
 * 显示两组数据的 diff
 * @param _old
 * @param _new
 * @returns
 */
export declare function diff<T>(_old: T[], _new: T[]): Diff<T>[];
/**
 * 合并两个数组, 保持最大相同子集合
 *
 *const old = [1, 2, 3, 4]
 *
  const new_ = [1, 0, 9, 3, 4]

  const merged = [1, 2, 0, 9, 3, 4]

 * @param _old
 * @param _new
 * @returns
 */
export declare function merge<T>(_old_d: Diff<T>[], _new_d: Diff<T>[]): Diff<T>[];
/**
 * 查找两个数组最大重叠区间
 *
 * a = [1, 2, 3, 4], b= [1, 3, 4 ,5, 6], 返回 [3,4]
 * @param a
 * @param b
 */
export declare function maxOverlap<T>(a: T[], b: T[]): {
    data: T[];
    a: number[];
    b: number[];
};
/**
 * s 是否包含 t,返回坐标
 * @param s
 * @param t
 */
export declare function isOverlap<T>(s: T[], t: T[]): number;
export {};
